package clientswing.UI;

import java.awt.*;
import javax.swing.*;

/**
 * <b>BaseForm</b>  la classe astratta da cui tutti i
 * frame ereditano valori di base quali localizzazione sullo schermo e
 *  il colore dello sfondo.
 * */

public abstract class BaseForm
    extends JFrame {

  /**costruttore della classe BaseForm*/
  public BaseForm() {
    //Toolkit e' una la superclasse astratta di tutte le attuali implementazioni di Abstract Window Toolkit.
    Toolkit kit = Toolkit.getDefaultToolkit();
    //prende le dimensioni dello schermo
    Dimension screenSize = kit.getScreenSize();

    //screenHeight contiene l'altezza dello schermo
    int screenHeight = screenSize.height;
    //screenWidth contiene l'ampiezza dello schermo
    int screenWidth = screenSize.width;

    // centra il frame sullo schermo
    setLocation(screenWidth / 4, screenHeight / 4);

    //assegna il colore di sfondo
    getContentPane().setBackground(Color.blue);
    //assegna come colore di sfondo il blu
    this.setBackground(Color.BLUE);

  }

}
