package clientswing.UI;

import javax.swing.*;
import java.awt.*;
import clientswing.model.*;
import java.awt.event.MouseEvent;



/**
* <i>DeleteForm</i> e' un pannello specializzazione di RequestPanel che consente all'utente di
* eliminare una tabella.
*/
public class DeletePanel
    extends JPanel
    implements RequestPanel {

  /**etichetta per il nome della tabella*/
  JLabel tableName = new JLabel();
  /**textField per inserire il nome della tabella */
  JTextField tableList = new JTextField();
  /**etichetta per un opzionale clausola WHERE nella query*/
  JLabel whereClause = new JLabel();
  /**gli viene assegnato il valore di delete che diventer il type del tag xrequest
   * del xml generato.*/
  String service;

  /**textfield per inserire il numero di campi da inserire*/
  JTextField columnNumSetWhere = new JTextField();


  /**bottone ok per l'inserimento dei campi della where*/
  JButton okWhere = new JButton();

  /**optionPanel  il pannello opzionale che si apre quando si clicca su ok del num di colonne*/
  OptionPanelInsertUpdate optionPanel;
  /**optionPanel  il pannello opzionale che si apre quando si clicca su ok del where*/
  OptionPanelInsertUpdate optionPanelWhere;


/**costruttore della classe DeletePanel*/
   public DeletePanel() {

    //imposto il valore dell'etichetta della tabella
    tableName.setText("Inserisci la Tabella");
    //imposto il posizionamento e la dimensione dell'etichetta della tabella
    tableName.setBounds(new Rectangle(10, 60, 130, 20));
    //imposto il colore dell'etichetta della tabella
    tableName.setForeground(Color.black);

    //imposto il posizionamento e la dimensione del textField della tabella
    tableList.setBounds(new Rectangle(200, 60, 75, 20));

    whereClause.setText("Where");
    whereClause.setBounds(new Rectangle(10, 90, 55, 20));
    whereClause.setForeground(Color.black);

    whereClause.setText("Inserisci i campi della where:");
    whereClause.setBounds(new Rectangle(10, 90, 180, 20));
    whereClause.setForeground(Color.black);
    columnNumSetWhere.setBounds(new Rectangle(200, 90, 20, 20));
    okWhere.setBounds(new Rectangle(230, 90, 45, 20));
    okWhere.setText("ok");
    okWhere.setFont(new java.awt.Font("Dialog", 0, 11));

    //catturo l'evento
    okWhere.addMouseListener(new DeletePanel_okWhere_mouseAdapter(this));

    service="delete";
    //aggiungo i componenti SWING al frame di Login
    this.add(tableName, null);
    this.add(tableList, null);
    this.add(whereClause, null);

    this.add(whereClause, null);
    this.add(columnNumSetWhere, null);
    this.add(okWhere, null);


    //chiamata al metodo init (ereditato da RequestPanel)per impostare le proprit al frame
    init(this);
  }

  /**
   * ritorna il nome della tabella
   * @param JTextField tableList
   * @return il nome della tabella da eliminare
   * */
  public String getTableList(JTextField tableList) {
    return tableList.getText();
  }

  /**
   * Metodo init ereditato da RequestPanel imposta le propriet del frame
   * @param JPanel pannello
   * @return non ritorna alcun valore
   * */
  public void init(JPanel pannello)
  {
    //vengono impostati dimensione e posizionamento del pannello
    pannello.setBounds(new Rectangle(30, 20, 280, 150));
    //viene utilizzato il posizionamento assoluto quindi non viene
    //impostato alcun LayoutManager
    pannello.setLayout(null);
    //viene impostato il colore di sfondo
    pannello.setBackground(Color.lightGray);
  }

  /**
     * Metodo getRequest ereditato da RequestPanel conserva i dati inseriti dall'utente
     * in una "struttura dati" rappresentata dalla classe XRequestQuery a partire dal
     * tipo di servizio scelto in questo caso delete
     *
     * @param String service servizio di cui si vuol disporre
     * @return XRequestQuery da inviare al ComunicationSystem
     * */

  public XRequestQuery getXRequest(String service) {

    //istanza di XRequestQuery in cui si andranno a conservare i dati inseriti dall'utente
    XRequestQuery request = new XRequestQuery();
    //conservo il tipo di servizio (delete) in request
    request.setService(service);
    //conservo il nome della tabella da eliminare
    request.setTableName(tableList.getText());
    //conservo la stringa rappresentante la clausola where opzionale
    Column[] columnsWhere = optionPanelWhere.getColumns();
     for (int i = 0; i < columnsWhere.length; i++)
     {
       request.addColumnWhere(columnsWhere[i]);
       System.out.println("\n" + columnsWhere[i] + "\n");
     }



    //ritorna la richiesta
    return request;
  }

  /**
   * ritorna il valore di service
   *
   * @return String
   */
  public String getService() {
    return service;
  }
  /**metodo che specifica al tasto okWhere di aprire il pannello contente labels e
   * textFields per riempire i campi di un where
   * */
  void okWhere_mouseClicked(MouseEvent e) {

    optionPanelWhere = new OptionPanelInsertUpdate(columnNumSetWhere);
    if (optionPanelWhere.getIsError() == false)
      optionPanelWhere.show();
  }

}
/**classe necessaria per creare l'evento catturato dal bottone okWhere*/
class DeletePanel_okWhere_mouseAdapter
    extends java.awt.event.MouseAdapter {
  DeletePanel adaptee;

  DeletePanel_okWhere_mouseAdapter(DeletePanel adaptee) {
    this.adaptee = adaptee;
  }

  public void mouseClicked(MouseEvent e) {
    adaptee.okWhere_mouseClicked(e);
  }
}
