package clientswing.UI;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import clientswing.model.*;

/**
 * <i>InsertUpdatePanel</i> e' un pannello specializzazione di RequestPanel che consente all'utente di
 * inserire o eliminare una tabella, impostando prima di ogni cosa il numero di colonne che
 * si intende coinvolgere. Per la gestione dei due servizi uso una variabile booleana
 * (<b>services</b>) che se impostata a:
* <ul>
*   <li>true si tratta di un servizio si INSERT</li>
*   <li>false si tratta di un servizio di UPDATE</li>
* </ul>
 */
public class InsertUpdatePanel
    extends JPanel
    implements RequestPanel {

  // OGGETTI SWING UTILIZZATI
  /** etichetta per il numero di colonne da inserire*/
  JLabel columnNum = new JLabel();

  /**textfield per inserire il numero di colonne da inserire*/
  JTextField columnNumSet = new JTextField();

  /** etichetta per il nome della tabella*/
  JLabel tableName = new JLabel();
  /** textField per il nome della tabella*/
  JTextField tableList = new JTextField();

 /**etichetta per un opzionale clausola WHERE nella query*/
  JLabel whereClause = new JLabel();

  /**textfield per inserire il numero di campi da inserire*/
    JTextField columnNumSetWhere = new JTextField();


  /**bottone ok per l'inserimento delle colonne*/
  JButton ok = new JButton();
  /**bottone ok per l'inserimento dei campi della where*/
  JButton okWhere = new JButton();

  /**optionPanel  il pannello opzionale che si apre quando si clicca su ok del num di colonne*/
  OptionPanelInsertUpdate optionPanel;
  /**optionPanel  il pannello opzionale che si apre quando si clicca su ok del where*/
  OptionPanelInsertUpdate optionPanelWhere;

  /**booleano che ci indica se il servizio  un Insert (false) oppure un Update (true)*/
  boolean services;
  /**gli viene assegnato il valore di insert o update che diventer il type del tag xrequest
  * del xml generato.*/


  String service;
/**costruttore della classe InsertUpdatePanel
   * @param boolean service*/
  public InsertUpdatePanel(boolean services) {
    columnNum.setText("Inserisci il numero di colonne");
    columnNum.setBounds(new Rectangle(10, 30, 180, 20));
    columnNum.setForeground(Color.black);

    columnNumSet.setBounds(new Rectangle(200, 30, 20, 20));

    tableName.setText("Inserisci la Tabella");
    tableName.setBounds(new Rectangle(10, 60, 130, 20));
    tableName.setForeground(Color.black);

    tableList.setBounds(new Rectangle(200, 60, 75, 20));

    whereClause.setText("Inserisci i campi della where:");
    whereClause.setBounds(new Rectangle(10, 90, 180, 20));
    whereClause.setForeground(Color.black);
    columnNumSetWhere.setBounds(new Rectangle(200, 90, 20, 20));
    okWhere.setBounds(new Rectangle(230, 90, 45, 20));
    okWhere.setText("ok");
    okWhere.setFont(new java.awt.Font("Dialog", 0, 11));

    ok.setBounds(new Rectangle(230, 30, 45, 20));
    ok.setText("ok");
    ok.setFont(new java.awt.Font("Dialog", 0, 11));

    //catturo l'evento
    ok.addMouseListener(new InsertUpdatePanel_ok_mouseAdapter(this));
    //catturo l'evento
    okWhere.addMouseListener(new InsertUpdatePanel_okWhere_mouseAdapter(this));

    //aggiungo i componenti SWING al frame di Login
    this.add(columnNum, null);
    this.add(columnNumSet, null);

    this.add(tableName, null);
    this.add(tableList, null);

    if (services == true) {
      service="update";
      this.add(whereClause, null);
      this.add(columnNumSetWhere, null);
      this.add(okWhere, null);
    }
    else
      service="insert";
    this.add(ok, null);

    init(this);
  }

  public String getTableList(JTextField tableList) {
    return tableList.getText();

  }

  public boolean getServices() {
    return services;

  }
/**inizializza alcune propriet del pannello*/
  public void init(JPanel pannello) {
    pannello.setBounds(new Rectangle(30, 20, 280, 150));
    pannello.setLayout(null);
    pannello.setBackground(Color.lightGray);

  }

  public XRequestQuery getXRequest(String service) {

    XRequestQuery request = new XRequestQuery();
    Column[] columnsWhere ;
    request.setService(service);
    request.setTableName(tableList.getText());

    if (service=="update") {
      columnsWhere = null;
      if (optionPanelWhere != null)
      {
        if (optionPanelWhere.getColumns().length > 0)
          columnsWhere = optionPanelWhere.getColumns();

          for (int i = 0; i < columnsWhere.length; i++) {
            request.addColumnWhere(columnsWhere[i]);
            System.out.println("\n" + columnsWhere[i] + "\n");
          }
      }

    }
    if (optionPanel == null)return request;

    Column[] columns = optionPanel.getColumns();
    for (int i = 0; i < columns.length; i++)
      request.addColumn(columns[i]);

    return request;
  }

  void ok_mouseClicked(MouseEvent e) {

    optionPanel = new OptionPanelInsertUpdate(columnNumSet);
    if (optionPanel.getIsError() == false)
      optionPanel.show();
  }
  void okWhere_mouseClicked(MouseEvent e) {

    optionPanelWhere = new OptionPanelInsertUpdate(columnNumSetWhere);
    if (optionPanelWhere.getIsError() == false)
      optionPanelWhere.show();
  }

  /**
   * getService
   *
   * @return String
   */
  public String getService() {
    return service;
  }
}

class InsertUpdatePanel_ok_mouseAdapter
    extends java.awt.event.MouseAdapter {
  InsertUpdatePanel adaptee;

  InsertUpdatePanel_ok_mouseAdapter(InsertUpdatePanel adaptee) {
    this.adaptee = adaptee;
  }

  public void mouseClicked(MouseEvent e) {
    adaptee.ok_mouseClicked(e);
  }
}
class InsertUpdatePanel_okWhere_mouseAdapter
    extends java.awt.event.MouseAdapter {
  InsertUpdatePanel adaptee;

  InsertUpdatePanel_okWhere_mouseAdapter(InsertUpdatePanel adaptee) {
    this.adaptee = adaptee;
  }

  public void mouseClicked(MouseEvent e) {
    adaptee.okWhere_mouseClicked(e);
  }
}
