package clientswing.UI;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import clientswing.model.XRequestLogin;

/**
* LoginForm e' un frame specializzazione di BaseForm che consente all'utente di inserire il proprio
* nickname e quindi di identificarsi.
*/
public class LoginForm extends BaseForm{
  /**etichetta per il nickName*/
  JLabel nickName = new JLabel();
  /**oggetto swing JTextField per inserire il nickName*/
  JTextField textLogin = new JTextField();
  /**bottone per inviare il nickName alla classe XRequestLogin*/
  JButton bottone =new JButton();
  /**oggetto XRequestLogin che contiene il nickName inserito*/
  XRequestLogin login  ;
  /**oggetto Controller che si occupa di eseguire la richiesta di Login*/
  Controller controller;

  /**costruttore della classe LoginForm*/
  public LoginForm()
  {
    //assegno il testo all'etichetta del nickName
     nickName.setText("Nickname");
     //assegno il posizionamento e la dimensione all'etichetta del nickName
     nickName.setBounds(new Rectangle(10, 20, 70, 20));
     //assegno il colore del testo all'etichetta del nickName
     nickName.setForeground(Color.white);

     //assegno il posizionamento e la dimensione al textField del nickName
     textLogin.setBounds(new Rectangle(80, 20, 140, 20));

    //assegno il testo al bottone invia
     bottone.setText("Invia");
     //assegno il posizionamento e la dimensione al bottone invia
     bottone.setBounds(new Rectangle(60,50,70,40));
     //assegno il colore di sfondo al bottone invia
     bottone.setBackground(Color.white);
     //assegno il colore del testo al bottone invia
     bottone.setForeground(Color.blue);

     //catturo un l'evento per il bottone invia
     bottone.addMouseListener(new bottone_mouseAdapter(this));

     //imposto il titolo del LoginFrame
     this.setTitle("Form di Login");
     //imposto la dimensione del LoginFrame
     this.setSize(250,150);
     //non imposto alcun layout
     this.getContentPane().setLayout(null);

     //aggiungo i componenti SWING al frame di Login
     this.getContentPane().add(nickName,null);
     this.getContentPane().add(textLogin,null);
     this.getContentPane().add(bottone,null);
 }
 /**
  * bottone_mouseClicked:
  * evento associato al bottone invia richiamato con un click del mouse
  * @param MouseEvent e
  * @return non ritorna alcun valore
  * */
  void bottone_mouseClicked(MouseEvent e) {
    //invia il nickName alla classe XRequestLogin
    login= new XRequestLogin(textLogin.getText());
    //esegue la richiesta di login
    Controller.getInstance().executeLogin(login);
    // nascondo la finestra
    this.hide();
  }

}
/**
 * bottone_mouseAdapter classe che estende java.awt.event.MouseAdapter
 * ed eredita il metodo mouseClicked che viene eseguito al click del mouse
 * */
 class bottone_mouseAdapter extends java.awt.event.MouseAdapter {
  LoginForm frame;
  /**costruttore della classe bottone_mouseAdapter
   * @param MouseEvent e
   * @return non ritorna alcun valore
   * */
  bottone_mouseAdapter(LoginForm frame) {
    this.frame = frame;
  }
  /**mouseClicked(MouseEvent e) metodo ereditato da java.awt.event.MouseAdapter
   * @param
   * */
  public void mouseClicked(MouseEvent e) {
    frame.bottone_mouseClicked(e);
  }


}
