package clientswing.UI;

import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import clientswing.model.*;

/**classe specializzazione di BaseForm,  un frame che viene visualizzato al click
* del tasto ok di SelectPanel per consentire all'utente di inserire le colonne della
* tabella su cui vuole effettuare la query.
* L'altezza del Pannello varia a seconda di quante colonne devono essere visualizzate.
*  */
public class OptionPanel
    extends BaseForm {
  /**array di etichette */
  JLabel[] labels =null;
  /**visualizza un messaggio di errore nel caso in cui non viene
   * inserito correttamente il numero di colonne
   * */
  JLabel errore = new JLabel();
  /**array di textField per inserire il nome della colonna*/
  JTextField[] textFields=null;
  /**array di colonne in cui vengono memorizzati i nomi delle colonne*/
  Column[] columns=new Column[3];
  /**bottone che invia i valori inseriti nel pannello*/
   JButton invia = new JButton("invia");
   /**textFied in cui viene inserito il numero di colonne*/
  JTextField columnNumSet;
  /**parametro che verifica se si  incontrato un errore*/
  boolean isError;

  /**costruttore della classe OptionPanel
   * @param JTextField columnNumSet,in cui  contenuto il numro di colonne
   * */
  public OptionPanel(JTextField columnNumSet) {

    Toolkit kit = Toolkit.getDefaultToolkit();
    Dimension screenSize = kit.getScreenSize();

    int screenHeight = screenSize.height;
    int screenWidth = screenSize.width;
    // centra il frame sullo schermo
    setSize(screenWidth / 2, screenHeight / 2);
    setLocation(screenWidth / 4 + 350, screenHeight / 4);

    this.getContentPane().setLayout(null);

    int num = 0;
    isError=false;
     try {
       num = Integer.parseInt(columnNumSet.getText());
       try {
         labels = new JLabel[num];
         textFields = new JTextField[num];

       }
       catch (Exception ex1) {
         columnNumSet.setBackground(Color.pink);
         labels = new JLabel[num];
         textFields = new JTextField[num];

       /*  errore.setBounds(new Rectangle(10, 40, 130, 20));
         errore.setForeground(Color.red);
         errore.setText("errore");*/
       JOptionPane.showMessageDialog(null, "errore di inserimento", "errore di inserimento", JOptionPane.WARNING_MESSAGE);
       isError=true;


       }
     }
     catch (NumberFormatException ex) {
      columnNumSet.setBackground(Color.pink);
      labels = new JLabel[num];
      textFields = new JTextField[num];

      JOptionPane.showMessageDialog(null, "errore di inserimento", "errore di inserimento", JOptionPane.WARNING_MESSAGE);
       invia.setVisible(false);
        isError=true;
     }

     int i;
     // columnErrore.setVisible(true);
     // columnName.setText("Inserisci la colonna");
      columnNumSet.setBackground(Color.white);
     for (i = 0; i < labels.length; i++) {


       labels[i] = new JLabel();
       labels[i].setText("Inserisci la colonna");

       labels[i].setBounds(new Rectangle(10, 40 + 25 * i, 130, 20));
       labels[i].setForeground(Color.black);
       textFields[i] = new JTextField();
       textFields[i].setBounds(new Rectangle(200, 40 + 25 * i, 70, 20));
       this.getContentPane().add(labels[i]);
       this.getContentPane().add(textFields[i]);
     }
     int height = 140 + num * 20;
     this.setSize(350, height);
     invia.setBounds(new Rectangle(150, 45 + 25 * i, 80, 20));
     invia.setBackground(Color.white);
     invia.setForeground(Color.gray);
     this.getContentPane().add(invia);
     this.getContentPane().add(errore);
     //catturo l'evento
      invia.addMouseListener(new OptionPanel_invia_mouseAdapter(this));




  }
/**metodo che assegna l'evento al bottone invia*/
   void invia_mouseClicked(MouseEvent e) {

    System.out.println("num="+labels.length+"\n");
    columns = new Column[labels.length];
    for (int i=0;i<labels.length;i++)
    {
       columns[i] = new Column(textFields[i].getText());
     }
    this.hide();
  }
 public boolean getIsError()
 {
   return isError;
 }
  public Column[] getColumns(){
    return columns;
 }
}


class OptionPanel_invia_mouseAdapter extends java.awt.event.MouseAdapter {
  OptionPanel adaptee;

  OptionPanel_invia_mouseAdapter(OptionPanel adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.invia_mouseClicked(e);
  }
}
