package clientswing.UI;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/**
* <i>QueryForm</i> e' un pannello specializzazione di BaseForm che consente all'utente di
* usufruire di uno dei servizi offerti dal WebServer quali:
* <ul>
* <li>Insert</li>
* <li>Update</li>
* <li>Delete</li>
* <li>Select</li>
* <li>Logout</li>
* </ul>
*
* Graficamente contiene un MenuBar su cui sono posti cinque bottoni uno per ogni servzio
* disponibile. A seconda di quale di questi viene premuto si visualizza il pannello
* corrispondente. Invia il tasto invia immagazzina i dati inseriti dall'utente e
* li invia al Controller il quale li invier al ComunicationSystem che a partire
* da quella richiesta gli invier la risposta.
*/

public class QueryForm extends BaseForm  {
  /**Oggetto JMenuBar*/
  JMenuBar menuBar=new JMenuBar();
  /** bottone per il servizio INSERT*/
  JButton menuInsert = new JButton("Insert");
  /** bottone per il servizio SELECT*/
  JButton menuSelect = new JButton("select");
  /** bottone per il servizio UPDATE*/
  JButton menuUpdate = new JButton("update");
    /** bottone per il servizio DELETE*/
  JButton menuDelete = new JButton("delete");
    /** bottone per il servizio LOGOUT*/
  JButton menuLogout = new JButton("Logout");
    /** bottone invia*/
  JButton invia =new JButton();
/**oggetto RequestPanel che verr istanziato come DeletePanel,InsertUpdatePanel o SelectPanel
   * a seconda di quale servizio viene richiesto.
   * */
  RequestPanel currPanel;

  int i;

//costruttore della classe QueryForm
public QueryForm()
{
  //vengon aggiunti i bottoni al MenuBar
  menuBar.add(menuInsert);
  menuBar.add(menuSelect);
  menuBar.add(menuUpdate);
  menuBar.add(menuDelete);
  menuBar.add(menuLogout);
  menuBar.setBorderPainted(true);
  menuSelect.addMouseListener(new QueryForm_menuSelect_mouseAdapter(this));
  menuInsert.addMouseListener(new QueryForm_menuInsert_mouseAdapter(this));
  menuDelete.addMouseListener(new QueryForm_menuDelete_mouseAdapter(this));
  menuUpdate.addMouseListener(new QueryForm_menuUpdate_mouseAdapter(this));
  menuLogout.addMouseListener(new QueryForm_menuLogout_mouseAdapter(this));

  invia.setText("Invia");
  invia.setBounds(new Rectangle(130,190,60,20));
  invia.setBackground(Color.white);
  invia.setForeground(Color.gray);
  invia.setFont(new java.awt.Font("Dialog", 1, 12));
  invia.addMouseListener(new QueryForm_invia_mouseAdapter(this));

  //propriet del form
  this.setTitle("Form di scelta dei servizi");
  this.setSize(350,280);
  this.getContentPane().setLayout(null);
  this.setJMenuBar(menuBar);
  // pannello.init(pannello);

 //this.getContentPane().add((JPanel)currPanel);

 this.getContentPane().setVisible(false);

 this.getContentPane().add(invia,null);

}
/**aziona levento per il bottone di selezione*/
void menuSelect_mouseClicked(MouseEvent e)
{

 setPanel( new SelectPanel());

}
  /**aziona levento per il bottone di delete*/
void menuDelete_mouseClicked(MouseEvent e)
{

  setPanel(new DeletePanel());

}
/**aziona levento per il bottone di insert*/
void menuInsert_mouseClicked(MouseEvent e)
{

  setPanel(new InsertUpdatePanel(false));

}
/**aziona levento per il bottone di update*/
void menuUpdate_mouseClicked(MouseEvent e)
{
  setPanel(new InsertUpdatePanel(true));
}
/**aziona levento per il bottone di logout*/
void menuLogout_mouseClicked(MouseEvent e) throws Exception
{
         String messageLogout= Controller.getInstance().executeLogout();
          JOptionPane.showMessageDialog(null, "Logout", messageLogout, JOptionPane.INFORMATION_MESSAGE);
}
/**rimuove il pannello corrente nel caso l'utente ha gi cliccato un bottone dei servizi
         * e decide di cambiarlo
         * @param RequestPanel p, pannello da viualizzare*/
 private void setPanel(RequestPanel p){
   if (currPanel!=null){
     System.out.println("Removing... ");
     this.getContentPane().setVisible(false);
     this.getContentPane().removeAll();
     this.getContentPane().add(invia,null);
     this.getContentPane().setVisible(true);

    }

    currPanel = p;

    this.getContentPane().add( (Component) currPanel);

    this.getContentPane().setVisible(true);

 }

/**aziona levento per il bottone di logout*/
  void invia_mouseClicked(MouseEvent e)
  {
     System.out.print("Clicked!!!!!!\n\n");
     System.out.print("service:"+currPanel.getService());

     Controller.getInstance().executeQuery( currPanel.getXRequest(currPanel.getService()));

  }

}

class QueryForm_menuSelect_mouseAdapter extends java.awt.event.MouseAdapter {
  QueryForm adaptee;

  QueryForm_menuSelect_mouseAdapter(QueryForm adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.menuSelect_mouseClicked(e);
  }
}

class QueryForm_menuInsert_mouseAdapter extends java.awt.event.MouseAdapter {
  QueryForm adaptee;

  QueryForm_menuInsert_mouseAdapter(QueryForm adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.menuInsert_mouseClicked(e);
  }
}
class QueryForm_menuUpdate_mouseAdapter extends java.awt.event.MouseAdapter {
  QueryForm adaptee;

  QueryForm_menuUpdate_mouseAdapter(QueryForm adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.menuUpdate_mouseClicked(e);
  }
}
class QueryForm_menuDelete_mouseAdapter extends java.awt.event.MouseAdapter {
  QueryForm adaptee;

  QueryForm_menuDelete_mouseAdapter(QueryForm adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.menuDelete_mouseClicked(e);
  }
}
class QueryForm_menuLogout_mouseAdapter extends java.awt.event.MouseAdapter {
  QueryForm adaptee;

  QueryForm_menuLogout_mouseAdapter(QueryForm adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e){
    try{
      adaptee.menuLogout_mouseClicked(e);
    }
    catch (Exception ex){
      System.out.println("Errore nella logout");
    }
  }
}

class QueryForm_invia_mouseAdapter extends java.awt.event.MouseAdapter {
  QueryForm adaptee;

  QueryForm_invia_mouseAdapter(QueryForm adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.invia_mouseClicked(e);
  }
}

