package clientswing.comunicationsystem;
import clientswing.model.*;
/**classe che a partire da un XRequest restituisce un XResponse.
* Mette in comunicazione l'interfaccia utente con le classi che comunicano con il WEBSERVER.*/
public class ComunicationSystem {
  /**oggetto XMLBuilder */
  XMLBuilder xmlBuilder;
  /**oggetto Gateway*/
  Gateway gateway;

/**costruttore della classe ComunicationSystem per compilare con le libreie di JAEBI
   * in localhost gateway deve essere istanziato come TestGateway altrimenti se vuole provare
   * con inidirizzo ip gateway deve essere istanziato come SOAPGateway.
   * Di default  posto come SOAPGateway.
   *
   * */
  public ComunicationSystem()
  throws Exception
  {

    gateway    = new SOAPGateway();
    xmlBuilder = new XMLBuilder();
  }
/**metodo che a partire da una richiesta di login attraverso il gateway ne verifica
   * l'avvenuto successo*/
  public XResponse execute(XRequestLogin nickName )
  throws Exception
  {

    gateway.sendLogin(nickName);

    return new XResponseMessage("Login successful for " + nickName.getNickName(),"");
  }
/**esegue il logout dell'utente
   * @return una stringa di messaggio del server*/
  public String execute()
    throws Exception
    {
      String logout;
      logout=gateway.logout();
      return logout;
    }
/**metodo che a partire da una richiesta di query attraverso l'oggetto xmlBuilder
     * costruisce la stringa contenente la richiesta in formato xml, attraverso il
     * gateway interroga il server e restituisce la risposta come una stringa contente xml.
       * */

  public XResponse execute(XRequestQuery xrequestQuery ) throws
      Exception{

    System.out.println("Executing query... ");
    System.out.println("Building XML... ");

    String xml = xmlBuilder.build(xrequestQuery);

    System.out.println("Sending query... ");
    String response = gateway.sendRequest(xml);
    System.out.println("\nResponse: \n\n" + response);
    XResponse xresponse = null;


    if (response!=null){
        System.out.println("Starting parsing of response..");
        xresponse = new XMLParser().parse(response);
        System.out.println("Parsing completed...");
    }

    return xresponse;
  }

  public static void main(String[] argv){
    XRequestQuery query = new XRequestQuery();

    query.setTableName("Pippo");
    //query.setWhereClause("where","where");
    query.addColumn(new Column("name"));

    try {
      ComunicationSystem cs = new ComunicationSystem();
      System.out.print( cs.execute(query) );

    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

  }

}
