package clientswing.comunicationsystem;

import clientswing.model.XRequestLogin;

import org.jaebi.client.ws.*;
import javax.xml.rpc.ServiceException;
import java.rmi.*;
/**classe implementazione dell'interfaccia Gateway che realizza la comunicazione tramite
* il protocollo SOAP*/
public class SOAPGateway implements Gateway{

  int sessionId;
  org.jaebi.client.ws.JAEBIWSSEI binding;

/**costruttore della classe SOAPGateway*/
  public SOAPGateway() throws ServiceException {

    binding = new JAEBIWS_Impl().getJAEBIWSSEIPort();

  }

  public String sendRequest(String request) {

       java.lang.String value = null;
       try{
         //value contiene il valore di risposta del server
         value = binding.executeRequest(sessionId, request);
       }catch(Exception e){
         e.printStackTrace();
         return null;
       }
       return value;

  }


  public int sendLogin(XRequestLogin login) {

    int value = 0;

    try {
      value = binding.login(login.getNickName(), "normal");
      sessionId = value;
      System.out.println("++++++++++++++"+sessionId+"++++++");
    }
    catch (RemoteException ex) {
      ex.printStackTrace();
      return -99;
    }
    return value;
  }

  /**
   * logout
   */
  public String logout() {
    String value = "";

       try {
         value = binding.logout(sessionId);
       }
       catch (RemoteException ex) {
         ex.printStackTrace();
         return null;
       }
       return value;

  }

}
