package clientswing.comunicationsystem;

import java.io.*;
import clientswing.model.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.*;
import org.w3c.dom.Element;

import java.util.Iterator;

/**classe che incapsula la richesta e crea una stringa contentente la stessa in formato xml*/
public class XMLBuilder
{
  /**rappresenta il documento DOM sul quale verr aggiunto l'albero DOM*/
  private Document doc;

  private DocumentBuilderFactory factory;
  private DocumentBuilder builder;
 // private InputSource source;

  public XMLBuilder()
  {

  }

  void init() throws ParserConfigurationException {
    factory = DocumentBuilderFactory.newInstance();
    factory.setNamespaceAware(true);
    factory.setValidating(true);
    builder = factory.newDocumentBuilder();
    doc = builder.newDocument();

  }

  public String xmlToString(Document doc) throws
      TransformerConfigurationException, TransformerException {
    TransformerFactory tFactory = TransformerFactory.newInstance();

    Transformer t = tFactory.newTransformer();

    StringWriter sw = new StringWriter();

    t.transform(new DOMSource(doc), new StreamResult(sw));

    return sw.toString();
  }
/**permette di aggiungere al tag columns del xml tante colonne quante se vengono richieste
   * @param Iterator colIt, permette di muoversi all'interno dell'arrayList
   * @return un elemento dell'albero DOM avente altri figli
   * */
  public Element xmlColumn(Iterator colIt,String stringa)
  {
     Element columns = doc.createElement("columns");
     Element column = doc.createElement("column");
     Element columnName  = doc.createElement("name");


     Element columnValue;
     Column col;

     while (colIt.hasNext()){
       column = doc.createElement("column");
       columnName  = doc.createElement("name");

       col = (Column) colIt.next();

       columnName.appendChild(doc.createTextNode(col.getName()));
       column.appendChild(columnName);

       if (col.getValue()!=null){
         columnValue = doc.createElement("value");
         columnValue.appendChild(doc.createTextNode(col.getValue()));
         column.appendChild(columnValue);

       }
       if (stringa.equals("table"))
         columns.appendChild(column);
     }
    if (stringa.equals("table"))
      return columns;
    else
      return column;
  }

/**costruisce la stringa xml a partire dalla richiesta*/
  public synchronized String build (XRequestQuery query) throws
      ParserConfigurationException, TransformerConfigurationException,
      TransformerException {

    init();
    Iterator colIt = query.getColumns().iterator();
    Iterator colItWhere = query.getWhere().iterator();
    Element root =  doc.createElement("xrequest");
    String stringa="table";
    Element queryNameTable = doc.createElement("table");
    queryNameTable.appendChild(doc.createTextNode(query.getTableName()));
    root.appendChild(queryNameTable);
    if (!query.getColumns().isEmpty()){
      Element columns = xmlColumn(colIt,stringa);

      root.appendChild(columns);
    }

    if (!query.getWhere().isEmpty()){
      Element queryWhereClause = doc.createElement("where");
      stringa="where";
      Element columnsWhere = xmlColumn(colItWhere,stringa);

      System.out.println("\n*** ");
      //queryWhereClause.appendChild(columnsWhere);
      queryWhereClause.appendChild(columnsWhere);
      root.appendChild(queryWhereClause);

    }

    root.setAttribute("xmlns","http://xml.netbeans.org/examples/targetNS");
    root.setAttribute("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
    root.setAttribute("xsi:schemaLocation","http://xml.netbeans.org/examples/targetNS xrequest.xsd");
    root.setAttribute("type",query.getService());

    doc.appendChild(root);

    root.normalize();

    return xmlToString(doc);


  }

  public static void main(String[] argv){

    XRequestQuery req = new XRequestQuery();

    req.setTableName("PippoTable");
    //req.setWhereClause("WHERE pippo = ","paperoga");
    req.setService("select");

    req.addColumn(new Column("nome","aldo"));
    req.addColumn(new Column("cognome"));
    try{
      System.out.print(new XMLBuilder().build(req));
    }catch(Exception e){
      e.printStackTrace();
    }

  }



}
